//-----------------------------------------------------------------------------
/*
Programmed by Olivier Sangala
http://olivier.sangala.free.fr
olivier_sangala@hotmail.com
*/
//-----------------------------------------------------------------------------

// From 'TICT Game Construction Kit' by Thomas Nussbaumer

//--------------------------------------------------------------------------
// KBLIB FUNCTIONS
//--------------------------------------------------------------------------

//-----------------------------------------------------------------------------

typedef unsigned short   KBSTATE;

//-----------------------------------------------------------------------------

// ============================================================================
// ============================================================================
// ==  keyboard handling                                                     ==
// ============================================================================
// ============================================================================

//-----------------------------------------------------------------------------
// the keyboard reading routine mimic the keyboard routine of the genlib in
// mean of which keys are used on which calculator.
//
// In detail the following keys are queried (depending on the calc type):
//
// flag set           TI-89     TI-92
// -------------------------------------------
// KEYFLAGS_ESC       ESC       ESC
// KEYFLAGS_UP        up        up
// KEYFLAGS_DOWN      down      down
// KEYFLAGS_LEFT      left      left
// KEYFLAGS_RIGHT     right     right
// KEYFLAGS_MODE      APPS      APPS
// KEYFLAGS_PLUS      +         +
// KEYFLAGS_MINUS     -         -
// KEYFLAGS_KA        2nd       F1
// KEYFLAGS_KB        Diamond   F2
// KEYFLAGS_KC        Home      F3
// KEYFLAGS_KD        X         F4
// KEYFLAGS_KE        Shift     F5
// KEYFLAGS_KF        Alpha     F6
// KEYFLAGS_KG        Mode      F7
// KEYFLAGS_KH        Y         F8
//
//-----------------------------------------------------------------------------


#define KEYFLAGS_ESC     0x0001
#define KEYFLAGS_UP      0x0002
#define KEYFLAGS_DOWN    0x0004
#define KEYFLAGS_LEFT    0x0008
#define KEYFLAGS_RIGHT   0x0010
#define KEYFLAGS_MODE    0x0020
#define KEYFLAGS_PLUS    0x0040
#define KEYFLAGS_MINUS   0x0080
#define KEYFLAGS_KA      0x0100
#define KEYFLAGS_KB      0x0200
#define KEYFLAGS_KC      0x0400
#define KEYFLAGS_KD      0x0800
#define KEYFLAGS_KE      0x1000
#define KEYFLAGS_KF      0x2000
#define KEYFLAGS_KG      0x4000
#define KEYFLAGS_KH      0x8000

//-----------------------------------------------------------------------------

#define KEYFLAGS_2ND     KEYFLAGS_KA
#define KEYFLAGS_DIAMOND KEYFLAGS_KB
#define KEYFLAGS_SHIFT   KEYFLAGS_KE
#define KEYFLAGS_ALPHA   KEYFLAGS_KF

//-----------------------------------------------------------------------------

#define WaitForAllKeysReleased() while(GetKeyboardState())

//-----------------------------------------------------------------------------

void KB_Enable(void);
void KB_Disable(void);
KBSTATE GetKeyboardState(void);
KBSTATE GetKeyboardState89(void);
KBSTATE GetKeyboardState92P(void);

void WaitForKeyDOWN(KBSTATE Key);
void WaitForKeyUP(KBSTATE Key);

void HandlerFuncPtr5(void); // TO BE IMPLEMENTED

//-----------------------------------------------------------------------------
